// AUTOGENERATED FILE - DO NOT MODIFY!
// This file generated by Djinni from Status.djinni

#pragma once

#include <cstdint>
#include <memory>
#include <optional>
#include <string>

namespace verifone_sdk {

class CommerceResponse;

/**
 * The session-specific extension of status. This object is returned to the
 * {@link CommerceListener CommerceListener}, and should never be constructed directly.
 */
class CommerceEvent {
public:
    virtual ~CommerceEvent() {}

    /** The type returned for a startSession request. */
    static std::string const SESSION_STARTED;

    /**  The type returned for a resumeSession request. */
    static std::string const SESSION_RESUMED;

    /** The type returned for an endSession request. */
    static std::string const SESSION_ENDED;

    /** The type returned when a session is closed, but not by a request to endSession. */
    static std::string const SESSION_CLOSED;

    /** A general error has occurred in the session that has stopped an unspecified method from being performed. */
    static std::string const SESSION_ERROR;

    /**
     * The generator method for generating the appropriate response for the current event.
     * This will always return a concrete subclass of {@link Response Response}.
     */
    virtual std::shared_ptr<CommerceResponse> generateResponse() const = 0;

    /**
     * Returns the event ID associated with this event. Useful for matching the event received by
     * the listener to the original status returned when issuing the call, for example, calling
     * {@link com.verifone.commerce.payment.TransactionManager#reprintReceipt(Payment)} returns a
     * CommerceEvent containing an event ID, which will match the event ID received by the
     * CommerceListener when the receipt reprint is complete.
     */
    virtual std::optional<std::string> getEventId() const = 0;

    /** return message from event */
    virtual std::optional<std::string> getMessage() const = 0;

    /** Get the session ID for the session which triggered this event. */
    virtual std::optional<std::string> getSessionId() const = 0;

    /**
     * Returns the Commerce Event constants in addition to the {@link Status Status} constants.
     * Overridden here only to provide the appropriate documentation.
     */
    virtual std::optional<std::string> getType() const = 0;

    /** Returns the event status */
    virtual int32_t getStatus() const = 0;
};

}  // namespace verifone_sdk
