// AUTOGENERATED FILE - DO NOT MODIFY!
// This file generated by Djinni from Status.djinni

#pragma once

#include <cstdint>
#include <optional>
#include <string>

namespace verifone_sdk {

/**
 * The main factory for all commerce responses. Please refer to the individual events that
 * generate the response for specific information.
 */
class CommerceResponse {
public:
    virtual ~CommerceResponse() {}

    /** Returns the session ID associated with this event, or null if detached from a session. */
    virtual std::optional<std::string> getSessionId() const = 0;

    /**
     * Returns the response type, generally a copy of the event type, or otherwise linked to the
     * type of event that generated this response.
     */
    virtual std::optional<std::string> getType() const = 0;

    /** Returns an optional event ID as copied from the originating event. */
    virtual std::optional<std::string> getEventId() const = 0;

    /** Returns the status of the response, non-zero if it encountered an error during handling */
    virtual int32_t getStatus() const = 0;

    /** Returns the message associated with the response, if it is conveying an error. */
    virtual std::optional<std::string> getMessage() const = 0;

    /** Refer to {@link #getStatus()}. */
    virtual void setStatus(int32_t status) = 0;

    /** Sets the status to the successful value, namely, 0. */
    virtual void setSuccessful() = 0;

    /** Sets the status to a general failed value. */
    virtual void setFailed() = 0;

    /** Refer to {@link #getMessage()}. */
    virtual void setMessage(const std::optional<std::string> & message) = 0;
};

}  // namespace verifone_sdk
