// AUTOGENERATED FILE - DO NOT MODIFY!
// This file generated by Djinni from com_verifone_commerce_payment.djinni

#pragma once

#include <cstdint>
#include <memory>
#include <optional>
#include <string>
#include <vector>

namespace verifone_sdk {

class Payment;
class Transaction;
class TransactionEventResponse;
class TransactionQuery;

/** Sent to the listener when a specific query is run from the ReportManager. */
class TransactionQueryEvent {
public:
    virtual ~TransactionQueryEvent() {}

    /** The event type. */
    static std::string const TYPE;

    /** Return message from event */
    virtual std::optional<std::string> getMessage() const = 0;

    /** Returns the session ID associated with this event, or null if detached from a session. */
    virtual std::optional<std::string> getSessionId() const = 0;

    /**
     * Returns the Transaction Event constants in addition to the {@link CommerceEvent CommerceEvent}
     * and {@link com.verifone.commerce.Status Status} constants. Overridden here only to
     * provide the appropriate documentation.
     */
    virtual std::optional<std::string> getType() const = 0;

    /** Return status */
    virtual int32_t getStatus() const = 0;

    /** Returns an optional event ID as copied from the originating event. */
    virtual std::optional<std::string> getEventId() const = 0;

    /** The invoice ID for the transaction. */
    virtual std::optional<std::string> getInvoiceId() const = 0;

    /**
     * The transaction object. Use {@link #updateTransaction(Transaction)} to apply any changes
     * for the transaction, or just update the transaction object returned by this method.
     */
    virtual std::shared_ptr<Transaction> getTransaction() const = 0;

    /** Returns true if the query retrieved any results, or false if no payments were found. */
    virtual bool foundPayments() const = 0;

    /** The payments retrieved by the query. */
    virtual std::vector<std::shared_ptr<Payment>> getPayments() const = 0;

    /** Returns a copy of the query that triggered this event. */
    virtual std::shared_ptr<TransactionQuery> getTransactionQuery() const = 0;

    /** TransactionEventResponse from the event */
    virtual std::shared_ptr<TransactionEventResponse> generateTransactionEventResponse() const = 0;
};

}  // namespace verifone_sdk
