// AUTOGENERATED FILE - DO NOT MODIFY!
// This file generated by Djinni from com_verifone_commerce_payment.djinni

#pragma once

#include <cstdint>
#include <memory>
#include <optional>
#include <string>
#include <vector>

namespace verifone_sdk {

class Image;
enum class InputType;
struct Decimal;

/** Values collected by the terminal. */
class Values {
public:
    virtual ~Values() {}

    /** Creates an instance of Values */
    static std::shared_ptr<Values> create();

    /**
     * Gets the response value when the Input Type is
     * {@link InputType#EMAIL},
     * {@link InputType#PASSWORD}, or
     * {@link InputType#TEXT}.
     */
    virtual std::optional<std::string> getValue() const = 0;

    /**
     * Sets the response value when the Input Type is
     * {@link InputType#EMAIL},
     * {@link InputType#PASSWORD}, or
     * {@link InputType#TEXT}.
     */
    virtual void setValue(const std::optional<std::string> & value) = 0;

    /**
     * Gets the response value when the Input Type is
     * {@link InputType#NUMBER} or
     * {@link InputType#DECIMAL}.
     */
    virtual std::optional<Decimal> getNumericValue() const = 0;

    /**
     * Sets the response value when the Input Type is
     * {@link InputType#NUMBER} or
     * {@link InputType#DECIMAL}.
     */
    virtual void setNumericValue(const std::optional<Decimal> & value) = 0;

    /**  Refer to {@link #setConfirmed(boolean)}. */
    virtual bool isConfirmed() const = 0;

    /**
     * Sets the response value when the Input Type is
     * {@link InputType#CONFIRMATION},
     * {@link InputType#MANAGER_APPROVAL}, or
     * {@link InputType#ANY_KEY}.
     */
    virtual void setConfirmed(bool confirmed) = 0;

    /** Refer to {@link #setSelectedIndices(Collection)}. */
    virtual std::vector<int32_t> getSelectedIndices() const = 0;

    /**
     * Used when the Input Type is {@link InputType#MENU_OPTIONS} to
     * provide back the selected index from the options.
     * a negative number means to go back to a previous menu
     */
    virtual void setSelectedIndices(const std::vector<int32_t> & indices) = 0;

    /** Refer to {@link #setImage(Bitmap)}. */
    virtual std::shared_ptr<Image> getImage() const = 0;

    /**
     * Used when the Input Type is {@link InputType#SIGNATURE} to provide
     * the image of the signature.
     */
    virtual void setImage(const std::shared_ptr<Image> & image) = 0;

    /** Validates the current values for the given Input Type. */
    virtual bool isValidForType(InputType inputType) const = 0;
};

}  // namespace verifone_sdk
